import sys
from antlr4 import *
from Includes.Defs import *
from Parser.VerilogAParser import VerilogAParser
from Parser.VerilogAListener import VerilogAListener
from Parser.VerilogALexer import VerilogALexer
from BranchCounter.CountTree import *

class Module:
    _tree = MyTree()

# This class implements the API to MyTree
# We will fill the Tree by stepping through the ParseTree and react to the
# tokens we find
class BranchCounterListener(VerilogAListener):
    _module = Module()

    def getModule(self):
        return self

    # add the BEGIN-NODE
    def enterModule_declaration (self, ctx):
        None

    # add the END-NODE
    def exitModule_declaration(self, ctx):
        self._module._tree.add_node(MyNode(Types.END))
        None

    # add the OP-NODE
    def enterProcedural_assignment(self, ctx):
        self._module._tree.add_node(MyNode(Types.OP, ctx.getText()))

    def exitTrue_statement(self, ctx):
        # check if a node is in the stack, so we are in the TRUE-CASE
        self._module._tree.add_node(MyNode(Types.END_TRUE))

    # Branch-contribution is just another assignment
    def enterBranch_contribution(self, ctx):
        self._module._tree.add_node(MyNode(Types.OP, ctx.getText()))

    def enterModule_item_declaration(self, ctx):
        None

    def enterConditional_statement(self, ctx):
        self._module._tree.add_node(MyNode(Types.BEGIN_IF, ctx.expression().getText()))
        None


    def exitConditional_statement(self, ctx):
        # add the END-IF-Node
        self._module._tree.add_node(MyNode(Types.END_FALSE))
        self._module._tree.add_node(MyNode(Types.END_IF))
        None
