from Includes.Defs import *

# MyNode implements the nodes of the Tree.
# The Node has the followign stuff:
# t:    type:   {analog_begin, analog_end, op, if, none, ...}
# v:    value:  the operation or assignment as string
# cnt:  counter:the actual count, how many pathes lead to the this node
# children: depending on the type
# You will find an example in the README
class MyNode:
    # create a node with the given type
    def __init__(self, t=Types.UNKNOWN, val=""):

        # check if type is ok:
        if(t == Types.UNKNOWN or type(t) != type(Types.UNKNOWN)):
            print("(!!) Error when adding a node!")
            exit(Errors.WRONG_TYPE)

        # initialize everything
        self._type = t
        self._val = val

        if (self._type == Types.BEGIN):
            self._child = MyNode(Types.EMPTY)
            return

        if (self._type == Types.END):
            None
            return

        if (self._type == Types.OP):
            self._child = MyNode(Types.EMPTY)
            return


        if (self._type == Types.BEGIN_TRUE):
            self._child = MyNode(Types.EMPTY)
            return

        if (self._type == Types.END_TRUE):
            self._child = MyNode(Types.EMPTY)
            return

        if (self._type == Types.BEGIN_FALSE):
            self._child = MyNode(Types.EMPTY)
            return

        if (self._type == Types.END_FALSE):
            self._child = MyNode(Types.EMPTY)
            return

        if (self._type == Types.END_IF):
            self._child = MyNode(Types.EMPTY)
            return

        if (self._type == Types.SWITCH):
            None
            return

        if (self._type == Types.EMPTY):
            None
            return

# MyTree implements the tree itself. The data
# will be saved in the tree structure. The list-like
# structure was a first idea. If neccessary i will implement
# it later, but for now it just has to work.
# The README has to be updated

# _act_node points to the last node, which usually is a node of type none.
# we need this to implement the branches.

class MyTree:
    _root = None
    _act_node = None
    _stack = []

    # We define the root here.
    def __init__(self):
        self._root = MyNode(Types.BEGIN)
        self._act_node = self._root

    def __str__(self):
        tmp = self._root
        self._stack.clear()
        while (True):
            if(tmp._type==Types.BEGIN):
                print ("{}({})".format(tmp._type, tmp._val))
                tmp = tmp._child
                continue
            if(tmp._type==Types.END):
                print ("{}({})".format(tmp._type, tmp._val))
                break
            if(tmp._type == Types.PREPROCESSOR):
                print ("{}({})".format(tmp._type, tmp._val))
                tmp = tmp._child
                continue
            if(tmp._type == Types.COMMENT):
                print ("{}({})".format(tmp._type, tmp._val))
                tmp = tmp._child
                continue
            if(tmp._type == Types.MODULE_DECLARATION):
                print("{} ({})".format(tmp._type, tmp._val))
                tmp = tmp._child
                continue
            if(tmp._type == Types.DECLARATION):
                print("{} ({})".format(tmp._type, tmp._val))
                tmp = tmp._child
                continue
            if(tmp._type==Types.BEGIN_ANALOG):
                if (tmp._child._type == Types.OP):
                    print("{} ({})".format(tmp._type, tmp._val))
                    tmp = tmp._child
                    print("{} ({})".format(tmp._type, tmp._val))
                else:
                    print("{} ({})".format(tmp._type, tmp._val))
                    tmp = tmp._child
                continue
            if(tmp._type==Types.OP):
                print("{} ({})".format(tmp._type, tmp._val))
                tmp = tmp._child
                continue
            if(tmp._type==Types.BEGIN_IF):
                print("{} ({})".format(tmp._type, tmp._val))
                tmp = tmp._child
                continue
            if(tmp._type==Types.BEGIN_TRUE):
                print ("{}{}({})".format(prefix, tmp._type, tmp._cnt))
                tmp = tmp._child
                continue
            if(tmp._type==Types.END_TRUE):
                indentLevel-=1
                prefix = "  " * indentLevel
                print ("{}{}({})".format(prefix, tmp._type, tmp._cnt))
                tmp = self._stack.pop()
                continue
            if(tmp._type==Types.BEGIN_FALSE):
                print("{} ({})".format(tmp._type, tmp._val))
                tmp = tmp._child
                continue
            if(tmp._type==Types.END_FALSE):
                indentLevel-=1
                prefix = "  " * indentLevel
                print ("{}{}({})".format(prefix, tmp._type, tmp._cnt))
                tmp = tmp._child
                continue
            if(tmp._type==Types.END_IF):
                indentLevel -=1
                prefix = "  " * indentLevel
                print ("{}{}({})".format(prefix, tmp._type, tmp._cnt))
                tmp = tmp._child
        return ''

    def print_tree(self, filename="/tmp/out.va"):
        tmp = self._root
        f = open(filename, "w")
        while (tmp._type != Types.END):
            if (tmp._type == Types.BEGIN_ANALOG): 
                f.write("{} ".format(tmp._val))
                tmp = tmp._child
                f.write("{}\n".format(tmp._val))
            elif (tmp._type == Types.BEGIN):
                None
            elif (tmp._type == Types.OP):
                # this line prints the strobe
                # f.write("$STROBE!!!\n")
                f.write("{}\n".format(tmp._val))
            else:
                f.write("{}\n".format(tmp._val))
            tmp = tmp._child
            continue
        

    
    # add a node and change self._act_node
    def add_node(self, node=None):
        if (node == None):
            print("(!!) no node was given!")
            exit(Errors.NO_NODE)

        # check if already finished before adding a node
        if (self._act_node._type == Types.END):
            print("(!!) Trying to add node after end!")
            exit(Errors.ADD_AFTER_END)
            
        if (node._type == Types.BEGIN_IF):
            self._act_node._child = node
            self._act_node =  self._act_node._child

        if (node._type == Types.END_TRUE):
            self._act_node._child = node
            self._act_node._child._cnt = self._act_node._cnt
            # save the END_TRUE-node as tmp and push on stack
            tmp = self._act_node._child
            self._act_node = self._stack.pop()
            self._stack.append(tmp)

        if (node._type == Types.END_FALSE):
            # change act_node._child to END_FALSE
            self._act_node._child = node
            self._act_node._child._cnt = self._act_node._cnt
            # and push END_FALSE on the stack
            self._stack.append(self._act_node._child)
            # now 2 END_NODES should be on the stack!

        if (node._type == Types.END_IF):
            #print("END_IF found")
            # take the 2 END_NODES from stack and add this node as their child

            tmp = self._stack.pop()
            cnt = tmp._cnt
            tmp._child = node

            tmp = self._stack.pop()
            cnt += tmp._cnt
            tmp._child = node
            self._act_node = node
            self._act_node._cnt = cnt

        if (node._type == Types.MODULE_DECLARATION):
            self._act_node._child = node
            self._act_node = self._act_node._child

        if (node._type == Types.DECLARATION):
            self._act_node._child = node
            self._act_node = self._act_node._child

        if (node._type == Types.OP):
            self._act_node._child = node
            self._act_node =  self._act_node._child

        if (node._type == Types.BEGIN_FALSE):
            self._act_node._child = node
            self._act_node =  self._act_node._child

        if (node._type == Types.PREPROCESSOR):
            self._act_node._child = node
            self._act_node = self._act_node._child

        if (node._type == Types.COMMENT):
            self._act_node._child = node
            self._act_node = self._act_node._child

        if (node._type == Types.BEGIN_ANALOG):
            self._act_node._child = node
            self._act_node = self._act_node._child

        if (node._type == Types.END):
            self._act_node._child = node
